<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}
function doshii_on_activation() {
	require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
	global $wpdb;
	$table_name = $wpdb->prefix . 'doshii_menu';
	$charset_collate = $wpdb->get_charset_collate();

	$sql = "CREATE TABLE $table_name (
        id bigint(20) NOT NULL AUTO_INCREMENT PRIMARY KEY,
        location_id varchar(100) NOT NULL,
        doshii_filtered_menu varchar(10) NOT NULL,
        doshii_monitor_stock varchar(10) NOT NULL,
        doshii_menu_version varchar(2000) NOT NULL,
		doshii_menu_updated varchar(100) NOT NULL,
		KEY {$table_name}_location_id (location_id)) $charset_collate;";
	dbDelta( $sql );

    // Mark the menu as not synchronised so after an update, the menu can be re-sync'ed without requiring a change in Doshii
	$wpdb->query("UPDATE $table_name SET doshii_menu_version = NULL;");


	$table_name = $wpdb->prefix . 'doshii_product';
	$charset_collate = $wpdb->get_charset_collate();

	$sql = "CREATE TABLE $table_name (
        id bigint(20) NOT NULL AUTO_INCREMENT PRIMARY KEY,
        doshii_product_name varchar(2000) NOT NULL,
		doshii_product_id varchar(100) NOT NULL,
		doshii_custom_id varchar(100) NOT NULL,
		KEY {$table_name}_custom_id (doshii_custom_id),
		KEY {$table_name}_product_id (doshii_product_id)) $charset_collate;";
	dbDelta( $sql );


	$table_name = $wpdb->prefix . 'doshii_product_option';
	$charset_collate = $wpdb->get_charset_collate();

	$sql = "CREATE TABLE $table_name (
        id bigint(20) NOT NULL AUTO_INCREMENT PRIMARY KEY,
        doshii_product_option_name varchar(2000) NOT NULL,
		doshii_product_option_id varchar(100),
        doshii_product_id varchar(100),
        doshii_custom_id varchar(100) NOT NULL,
        KEY {$table_name}_option_id (doshii_product_option_id),
        KEY {$table_name}_product_custom_id (doshii_product_id, doshii_custom_id),
        KEY {$table_name}_product_option_id (doshii_product_id, doshii_product_option_id)) $charset_collate;";
	dbDelta( $sql );


	$table_name = $wpdb->prefix . 'doshii_product_variant';
	$charset_collate = $wpdb->get_charset_collate();

	$sql = "CREATE TABLE $table_name (
        id bigint(20) NOT NULL AUTO_INCREMENT PRIMARY KEY,
        doshii_product_variant_name varchar(2000) NOT NULL,
		doshii_product_variant_id varchar(100) NOT NULL,
        doshii_product_id varchar(100) NOT NULL,
		doshii_product_option_id varchar(100) NOT NULL,
		doshii_custom_id varchar(100) NOT NULL,
        KEY {$table_name}_product_custom_id (doshii_product_id, doshii_product_option_id, doshii_custom_id),
        KEY {$table_name}_product_variant_id (doshii_product_id, doshii_product_option_id, doshii_product_variant_id)) $charset_collate;";
	dbDelta( $sql );
}
?>
