<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}
include('woo-doshii-build-dropdown.php');
add_action( 'woocommerce_product_options_related', 'display_linked_products_data_custom_field' );
function display_linked_products_data_custom_field() {
    global $wpdb;
    global $product_object, $post, $product;

    $doshii_product_tbl  = $wpdb->prefix . 'doshii_product';
    $doshii_sql = "SELECT * FROM $doshii_product_tbl ORDER BY doshii_product_name ASC";
    $doshii_results = $wpdb->get_results($doshii_sql) or array();
    if (!empty($doshii_results)) {
        $product_ids = $product_object->get_meta( '_doshii_posId' );
    ?>

    <span class="overlay_section"></span>
    <p class="form-field">
        <label for="subscription_toggle_products"><?php _e( 'Doshii Product', 'woocommerce' ); ?></label>
        <select onchange="doshiiParent_id(this)"  id="doshii_posId" name="_doshii_posId">
        <option value="">Select Doshii Product</option>
           <?php
            $productId = is_array($product_ids) ? $product_ids[0] : $product_ids;
            foreach ( $doshii_results as $product_id ) {
                $selected='';
                if(!empty($productId) && $productId === $product_id->doshii_product_id){ $selected = selected( true, true, false ); }
                echo '<option '.$selected.' value="' . esc_attr( $product_id->doshii_product_id ) . '">' . wp_kses_post( $product_id->doshii_product_name) . '</option>';
            }
            ?>
        </select>
    </p>

    <?php
        $doshii_option_results = array();
        if (!empty($productId)) {
            $doshii_product_option_tbl  = $wpdb->prefix . 'doshii_product_option';
            $doshii_option_sql = "SELECT * FROM $doshii_product_option_tbl where doshii_product_id='$productId'";
            $doshii_option_results = $wpdb->get_results($doshii_option_sql);
            $product_option_ids = $product_object->get_meta( '_doshii_option_posId' );
            $optionId = is_array($product_option_ids) ? $product_option_ids[0] : $product_option_ids;
        }
    ?>

    <p style="<?php if(count($doshii_option_results) > 0){ echo 'display:block'; }else{ echo 'display:none'; } ?>" class="form-field doshii_option_posId">
        <label for="subscription_toggle_products"><?php _e( 'Doshii Product Option', 'woocommerce' ); ?></label>

            <select readonly onchange="doshii_variant_id(this)" id="doshii_option_posId" name="_doshii_option_posId">
            <option value="">Select options</option>
            <?php
                foreach($doshii_option_results as $options){
                    if (!empty($optionId) && $options->doshii_product_option_id === $optionId) {
                        $selected = selected( true, true, false );
                        echo '<option  '.$selected.' value="' . esc_attr( $options->doshii_product_option_id ) . '">' . wp_kses_post( $options->doshii_product_option_name) . '</option>';
                    } else {
                        echo '<option value="' . esc_attr( $options->doshii_product_option_id ) . '">' . wp_kses_post( $options->doshii_product_option_name) . '</option>';
                    }
                }
             ?>
            </select>
    </p>

    <?php
        $doshii_variant_results = array();
        if (!empty($optionId)) {
            $product_variant_ids = $product_object->get_meta( '_doshii_variant_posId' );
            $variantId = is_array($product_variant_ids) ? $product_variant_ids[0] : $product_variant_ids;
            $doshii_product_variant_tbl  = $wpdb->prefix . 'doshii_product_variant';
            $doshii_variant_sql = "SELECT * FROM $doshii_product_variant_tbl where doshii_product_id='$productId' AND doshii_product_option_id='$optionId'";
            $doshii_variant_results = $wpdb->get_results($doshii_variant_sql);
        }
    ?>

    <p style="<?php if(count($doshii_variant_results) > 0){ echo 'display:block'; }else{ echo 'display:none'; } ?>" class="form-field doshii_variant_posId">
        <label for="subscription_toggle_products"><?php _e( 'Doshii Product Variant', 'woocommerce' ); ?></label>
        <select readonly multiple="multiple" id="doshii_variant_posId" name="_doshii_variant_posId[]">
        <?php
            foreach($doshii_variant_results as $variantdata){
                if (!empty($variantId) && $variantdata->doshii_product_variant_id === $variantId) {
                    $selected = selected( true, true, false );
                    echo '<option '.$selected.' value="' . esc_attr( $variantdata->doshii_product_variant_id ) . '">' . wp_kses_post( $variantdata->doshii_product_variant_name) . '</option>';
                } else {
                    echo '<option value="' . esc_attr( $variantdata->doshii_product_variant_id ) . '">' . wp_kses_post( $variantdata->doshii_product_variant_name) . '</option>';
                }
            }
        ?>
        </select>
    </p>

    <?php
    include('woo-doshii-ajax.php');
    }
}


// Save the values to the product
add_action( 'woocommerce_admin_process_product_object', 'save_linked_products_data_custom_field_value', 10, 1 );
function save_linked_products_data_custom_field_value( $product ) {
    $data = isset( $_POST['_doshii_posId'] ) ? $_POST['_doshii_posId'] : '';
    $product->update_meta_data( '_doshii_posId', $data );

	$Optiondata = isset( $_POST['_doshii_option_posId'] ) ? $_POST['_doshii_option_posId'] : '';
    $product->update_meta_data( '_doshii_option_posId', $Optiondata );

	$Variantdata = isset( $_POST['_doshii_variant_posId'] ) ? $_POST['_doshii_variant_posId'] : '';
    $product->update_meta_data( '_doshii_variant_posId', $Variantdata );
}

add_filter( 'manage_edit-product_columns', 'doshii_show_product_id',15 );
function doshii_show_product_id($columns) {

   //add column
   $updatedColumns = array_slice($columns, 0, count($columns) - 1, true) +
               array('doshii_product_map' => __('Doshii ID', 'doshii')) +
               array_slice($columns, count($columns) - 1, NULL, true);

   return $updatedColumns;
}

add_action( 'manage_product_posts_custom_column', 'doshii_populate_doshii_product_map', 10, 2 );
function doshii_populate_doshii_product_map( $column, $postid ) {
    if ($column == 'doshii_product_map') {
        $productIds = get_post_meta( $postid, '_doshii_posId', true);

        $productId = isset($productIds) ? (is_array($productIds) ? $productIds[0] : $productIds) : '';
        if (!empty($productId)) {
            $optionIds = get_post_meta( $postid, '_doshii_option_posId', true);
            $optionId = '';
            $variantId = '';
            if (isset($optionIds)) {
                if (is_array($optionIds)) {
                    $optionId = !empty($optionIds[0]) ? "<br /><span style=\"margin-left: 15px;\">→ {$optionIds[0]}</span>" : '';
                } else {
                    $optionId = !empty($optionIds) ? "<br /><span style=\"margin-left: 15px;\">→ {$optionIds}</span>" : '';
                }

                $variantIds = get_post_meta( $postid, '_doshii_variant_posId', true);
                if (isset($variantIds)) {
                    if (is_array($variantIds)) {
                        $variantId = !empty($variantIds[0]) ? "<br /><span style=\"margin-left: 32px;\">→ {$variantIds[0]}</span>" : '';
                    } else {
                        $variantId = !empty($variantIds) ? "<br /><span style=\"margin-left: 32px;\">→ {$variantIds}</span>" : '';
                    }
                }
            }
            $value = "{$productId}{$optionId}{$variantId}";
        }
        echo (empty($value) ? '-' : $value);
    }
}
?>
